All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # - automate builds with sbuild and dinstall the result
5 # Copyright (c) 2008 martin f. krafft <madduck@debian.org>
6 # Released under the terms of the Artistic Licence 2.0.
12 BUILDDIR="$(mktemp -dt $ME.XXXXXXXX)"
13 trap "cd /tmp && rm -r '$BUILDDIR'" 0
15 BUNDLE_DIR="${TMPDIR:-/tmp}"
18 echo "Copying files destined for $1 back to $TARGET_DIR..."
19 dcmd cp -v "$2" "$TARGET_DIR"
24 print_bundle_location() {
25 echo "Bundle available at $@ ."
30 MBUILDRCS="/etc/mbuild/rc $HOME/.mbuildrc $HOME/.mbuild/rc"
31 for rc in $MBUILDRCS; do
32 [ -r "$rc" ] && . "$rc"
35 if [ -z "$KEYID" ]; then
36 echo "E: \$KEYID is not defined in rc file." >&2
40 DEB_BUILD_ARCH="$(dpkg-architecture -qDEB_BUILD_ARCH)"
44 echo "$ME -- wrapper for sbuild"
45 echo "Copyright © martin f. krafft <madduck@debian.org>"
46 echo "Released under the terms of the Artistic Licence 2.0"
53 echo "Usage: $ME [options] [sbuild_options] file_source.changes"
55 echo "Valid options are:"
56 cat <<-_eof | column -s\& -t
57 --dist & specify the target distribution (default: from changes file)
58 --arch & specify the target architecture (default: $DEB_BUILD_ARCH)
59 -sa & pass --force-orig-source to sbuild
60 -B & do a binary-only build
61 -h|--help & show this output.
62 -V|--version & show version information.
72 -h|--help) usage; exit 0;;
73 -V|--version) about; exit 0;;
74 --arch=*) arch="${opt#--arch=}";;
75 -D) sbuild_args="${sbuild_args:+$sbuild_args }$opt";;
76 -sa) sbuild_args="${sbuild_args:+$sbuild_args }--force-orig-source";;
78 --*) sbuild_args="${sbuild_args:+$sbuild_args }$opt";;
80 if [ -z "$schangesfile" ]; then
81 if [ -f "$opt" ] && [ -r "$opt" ]; then
84 echo "E: file does not exist: $opt" >&2
88 echo "E: cannot pass more than one source changes file: $opt" >&2
93 echo "E: unknown option: $opt" >&2
99 if [ -z "$schangesfile" ]; then
104 [ -z "$arch" ] && arch="$DEB_BUILD_ARCH"
106 dist="$(sed -ne 's,Distribution: ,,p' "$schangesfile")"
108 schangesfile_basename="${schangesfile##*/}"
109 packagename="${schangesfile_basename%%_*}"
110 packagenameversion="${schangesfile_basename%_*}"
111 debversion="${packagenameversion#*_}"
112 upstream_version="${debversion%-*}"
113 dscfile_basename="$packagenameversion".dsc
115 case "$schangesfile" in
116 */*) cd "${schangesfile%/*}";;
119 dcmd cp "${schangesfile##*/}" "$BUILDDIR"
120 schangesfile="$schangesfile_basename"
125 dcmd "$dscfile_basename" | while read f; do
126 test -f "$f" && continue
129 *.tar.gz|*.tar.bz2|*.tar.lzma|*.tar.xz)
130 if [ -f "$OLDPWD/$f" ]; then
131 echo "I: using existing tarball for $upstream_version…" >&2
134 last_version="$(apt-cache madison $packagename | sed -rne "s,.+(\<${upstream_version}[^[:space:]]+).*,\1,p")"
135 echo "I: fetching missing tarball for $upstream_version (from $last_version)…" >&2
136 if ! apt-get --tar-only --only-source source "${packagename}=${last_version}"; then
137 echo "E: I do not know how to obtain the file: $f" >&2
143 echo "E: I do not know how to obtain the file: $f" >&2
149 [ "$binonly" = 0 ] && sbuild_args="${sbuild_args:+$sbuild_args }--source --arch-all"
151 sbuild $sbuild_args --arch="$arch" --dist="$dist" --keyid=$KEYID \
154 changesfile="${packagenameversion}_${arch}.changes"
156 #mergechanges "$schangesfile" "$changesfile" > temp-combined.changes
157 #mv temp-combined.changes "$changesfile"
158 #changestool "$changesfile" updatechecksums
160 #sign_changes_file "$changesfile"
162 dinstall "$dist" "$changesfile"
164 DATESTR="$(date +%Y.%m.%d.%H%M%S)"
165 BUILD_PREFIX="${packagenameversion}_${arch}.${DATESTR}"
167 mv current "${BUILD_PREFIX}".buildlog
170 bundle="${BUNDLE_DIR}/${BUILD_PREFIX}".bundle.tar
177 print_bundle_location "$bundle"